'
' ######################
' #####  MD3_Load  #####
' ######################
'
FUNCTION MD3_Load (name$,loadshader)
MD3Header Header
MD3Surface surface
MD3Shader	shader
MD3Tag	tag
MD3Frame frame
SHARED tMD3Model MD3m[]
SHARED tMD3ModelFrames MD3f[]
SINGLE x,y,z,normal,lng,lat
SBYTE tp[]
SINGLE tptex
SINGLE lmatrix[15]
SHARED MD3_INFOS MD3i

debug_push("MD3_Load ("+name$+")")

DIM tp[7]

name$="models/"+name$

model=MD3_CheckExists(name$)

IF model>-1 THEN
debug_pop()
RETURN(model)
ENDIF

model=MD3_New()
IF model=-1 THEN
debug_pop()
RETURN (-1)
ENDIF

Hdl=@MD3i.fOpen(name$,$$RD)
@MD3i.fRead(Hdl,&Header,SIZE(MD3Header))

IF ( Header.strID <> "IDP3" ) THEN
		info$="MD3_Load:"+name$+" Bad file "+Header.strID+" Version "+STRING$(Header.version)
		@MD3i.Print (info$)
		@MD3i.fClose (Hdl)
		debug_pop()
		RETURN ($$FALSE)
		ELSE
		info$="MD3_Load:"+name$+"==>"+Header.strID+" Version "+STRING$(Header.version)
		@MD3i.Print (info$)
		ENDIF

		'GFX_SyncRenderFrame ($$GFX_Phase_Model,"Loading Model:"+STRING$(name$))

@MD3i.Print(STRING$(Header.nSurfaces)+" Surfaces - "+STRING$(Header.nFrames)+" Frames")
@MD3i.Print("Building...")

MD3m[model].nSurfaces = Header.nSurfaces
MD3m[model].nFrames = Header.nFrames
MD3m[model].nTags = Header.nTags
MD3m[model].strName=name$


psurface=Header.oSurfaces

FOR i=0 TO Header.nSurfaces-1

@MD3i.fSeek (Hdl,psurface)
@MD3i.fRead (Hdl,&surface,SIZE(MD3Surface))

MD3m[model].surface[i].strName=surface.strName

'Triangles reading

addroTris = psurface + surface.oTriangles
stris = surface.nTriangles * 12 'memory allocation for triangles
addrnTris = @MD3i.mAlloc(stris)
MD3m[model].surface[i].pTriangles=addrnTris
MD3m[model].surface[i].nTriangles=surface.nTriangles
'Load directly , no transform
@MD3i.fSeek(Hdl,addroTris)
@MD3i.fRead(Hdl,addrnTris,stris)

'TxCoord reading

addroTx = psurface + surface.oTxCoords
stx = surface.nVerts * 8 'memory allocation for texcoords
addrnTx = @MD3i.mAlloc(stx)
MD3m[model].surface[i].pTxCoords = addrnTx
'Load directly, no transform
@MD3i.fSeek(Hdl,addroTx)
@MD3i.fRead(Hdl,addrnTx,stx)
'Texcoords are vertically reversed
FOR j=0 TO surface.nVerts-1
	adr=addrnTx+(j*8)
	tptex=SINGLEAT(adr+4)
	tptex=1-tptex
	SINGLEAT(adr+4)=tptex
NEXT

'Vertices reading
nVerts = surface.nVerts * surface.nFrames
sFrame = surface.nVerts * 24
sFrameo = surface.nVerts * 8
addroVert = psurface + surface.oVertices
addrnVert = @MD3i.mAlloc(sFrame * surface.nFrames)
MD3m[model].surface[i].pVerts=addrnVert
MD3m[model].surface[i].sFrame=sFrame
'Load and convert x16,y16,z16,normal16 ==> x32,y32,z32,xnormal32,ynormal32,znormal32

FOR k=0 TO surface.nFrames-1
FOR j=0 TO surface.nVerts-1
	@MD3i.fSeek(Hdl,addroVert+(j*8))
adr=addrnVert + (j*24)
@MD3i.fRead (Hdl,&tp[],8)
adrx=&tp[0]
adry=&tp[2]
adrz=&tp[4]
adrn=&tp[6]
x=SINGLE(SSHORTAT (adrx))
y=SINGLE(SSHORTAT (adry))
z=SINGLE(SSHORTAT (adrz))

'ID formats use X=L Y=W Z=H , opengl X=L Y=H Z=-H

SINGLEAT(adr) = x/64!
SINGLEAT(adr+4) = z/64!
SINGLEAT(adr+8) = - (y/64!)

'normals crazy lat/lng calculation !
lat=(USHORTAT (adrn) >>8) AND 255
lat=lat*SINGLE($$PI)*2!
lat=lat/255!


lng=USHORTAT(adrn) AND 255
lng=lng*SINGLE($$PI)*2!
lng=lng/255!

x = Cos ( lat ) * Sin ( lng )
y = Sin ( lat ) * Sin ( lng )
z = Cos ( lng )

SINGLEAT(adr+12) = x
SINGLEAT(adr+16) = z
SINGLEAT(adr+20) = -y

NEXT
addroVert=addroVert+sFrameo
addrnVert=addrnVert+sFrame
NEXT

'Shader reading and creating , i don't care here about skins but that is possible to add skin support here
addrshader=psurface+surface.oShaders
@MD3i.fSeek(Hdl,addrshader)
@MD3i.fRead(Hdl,&shader,SIZE(MD3Shader))
a$=shader.strName
a$=LEFT$(a$,LEN(a$)-4)
IF loadshader THEN MD3m[model].surface[i].shaderID=@MD3i.SHADER_Load(a$)

psurface=psurface+surface.oEND

NEXT

'TAGs reading
@MD3i.fSeek(Hdl,Header.oTags)
'Tag names are stored in model...
FOR i=0 TO Header.nTags-1
	@MD3i.fRead (Hdl,&tag,SIZE(MD3Tag))
	MD3m[model].strTagName[i]=tag.strName
	'@MD3i.Print(tag.strName)
NEXT
'...and Tag datas in frame
@MD3i.fSeek(Hdl,Header.oTags)
FOR j=0 TO Header.nFrames-1
	FOR i=0 TO Header.nTags-1
		@MD3i.fRead(Hdl,&tag,SIZE(MD3Tag))

		SWAP tag.origin.y , tag.origin.z
		tag.origin.z = - tag.origin.z
		MD3f[model].cFrame[j].tag[i].origin=tag.origin

		'Transform 3x3 to 4x4 and to a quaternion

		MD3_MATH_Mat3x3ToMat4x4 (&tag.rotmatrix[],&lmatrix[])
		MD3_MATH_MatrixToQuat (&lmatrix[],&MD3f[model].cFrame[j].tag[i].quat)

	NEXT
NEXT

'FRAMES reading
'direct load, and x/z/-y convertion
@MD3i.fSeek(Hdl,Header.oFrames)
FOR i=0 TO Header.nFrames-1
@MD3i.fRead(Hdl,&MD3f[model].cFrame[i].frame,SIZE(MD3Frame))
SWAP MD3f[model].cFrame[i].frame.boxmin.y,MD3f[model].cFrame[i].frame.boxmin.z
MD3f[model].cFrame[i].frame.boxmin.z=-MD3f[model].cFrame[i].frame.boxmin.z

SWAP MD3f[model].cFrame[i].frame.boxmax.y,MD3f[model].cFrame[i].frame.boxmax.z
MD3f[model].cFrame[i].frame.boxmax.z=-MD3f[model].cFrame[i].frame.boxmax.z
NEXT

MD3m[model].flags = $$MD3_LOADED
@MD3i.fClose(Hdl)
debug_pop()
RETURN (model)

END FUNCTION
'
' ######################
' #####  MD3_Init  #####
' ######################
'
FUNCTION MD3_Init (maxmd3,flags)
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i
SHARED tMD3ModelFrames MD3f[]
debug_push("MD3_Init ("+STRING$(maxmd3)+")")

IF MD3_AsmInit ()=-1 THEN
	RETURN (-1)
ENDIF

MD3i.LastModel = -1
MD3i.Maxmodels = maxmd3

DIM MD3m[maxmd3]
DIM MD3f[maxmd3]

MD3i.flags =  flags

debug_pop()

END FUNCTION
'
' ######################
' #####  MD3_Free  #####
' ######################
'
FUNCTION MD3_Free (model)
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i
debug_push("MD3_Free ("+STRING$(model)+")")
FOR i=0 TO MD3m[model].nSurfaces-1

	IF MD3m[model].surface[i].pTriangles THEN @MD3i.mFree(MD3m[model].surface[i].pTriangles)
	IF MD3m[model].surface[i].pTxCoords THEN @MD3i.mFree(MD3m[model].surface[i].pTxCoords)
	IF MD3m[model].surface[i].pVerts THEN @MD3i.mFree(MD3m[model].surface[i].pVerts)
	IF MD3m[model].surface[i].shaderID THEN
		@MD3i.SHADER_Free(MD3m[model].surface[i].shaderID)
	ENDIF
debug_pop()
NEXT


END FUNCTION
'
' #################################
' #####  MD3_INSTANCE_Create  #####
' #################################
'
FUNCTION MD3_INSTANCE_Create (model,tMD3instance instance)
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i
debug_push("MD3_INSTANCE_Create ("+STRING$(model)+","+HEXX$(&instance)+")")
instance.model = model

IF (MD3m[model].flags AND $$MD3_LOADED) THEN
	instance.nSurfaces=MD3m[model].nSurfaces
	FOR i=0 TO MD3m[model].nSurfaces-1
		IF MD3m[model].surface[i].pVerts THEN
			instance.surfaceflags[i]=0
			sFrame=MD3m[model].surface[i].sFrame
			instance.pVerts[i]=@MD3i.mAlloc(sFrame)

			nTris=MD3m[model].surface[i].nTriangles

			IF (MD3i.flags AND $$MD3_USE_SHADOWS) THEN
			nTris=nTris*4
			instance.pShadowFrontTris[i]=@MD3i.mAlloc(nTris)
			nEdges=(nTris*3)*3
			instance.pShadowEdges[i]=@MD3i.mAlloc(nEdges)
			ENDIF

		ENDIF
	instance.shaderID[i]= MD3m[model].surface[i].shaderID 'instances inherit default shaders
	NEXT
ENDIF

'Wrappers creation
Addrinst=&instance

'Add Wrapper for Destroy
Addrfunc=&MD3_INSTANCE_Destroy()
instance.Destroy = &instance.bDestroy[]
Adrnewcode=instance.Destroy
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for BuildStatic
Addrfunc=&MD3_INSTANCE_BuildStatic()
instance.BuildStatic = &instance.bBuildStatic[]
Adrnewcode=instance.BuildStatic
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for BuildAnim
Addrfunc=&MD3_INSTANCE_BuildAnim()
instance.BuildAnim = &instance.bBuildAnim[]
Adrnewcode=instance.BuildAnim
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for SetIdentity
Addrfunc=&MD3_INSTANCE_SetIdentity()
instance.SetIdentity = &instance.bSetIdentity[]
Adrnewcode=instance.SetIdentity
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for GetTagID
Addrfunc=&MD3_INSTANCE_GetTagID()
instance.GetTagID = &instance.bGetTagID[]
Adrnewcode=instance.GetTagID
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for Link
Addrfunc=&MD3_INSTANCE_Link()
instance.Link = &instance.bLink[]
Adrnewcode=instance.Link
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for ShowBox
Addrfunc=&MD3_INSTANCE_ShowBox()
instance.ShowBox = &instance.bShowBox[]
Adrnewcode=instance.ShowBox
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for GetSurfaceID
Addrfunc=&MD3_INSTANCE_GetSurfaceID()
instance.GetSurfaceID = &instance.bGetSurfaceID[]
Adrnewcode=instance.GetSurfaceID
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for SetSurfaceShader
Addrfunc=&MD3_INSTANCE_SetSurfaceShader()
instance.SetSurfaceShader = &instance.bSetSurfaceShader[]
Adrnewcode=instance.SetSurfaceShader
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for SetViewVector
Addrfunc=&MD3_INSTANCE_SetViewVector()
instance.SetViewVector = &instance.bSetViewVector[]
Adrnewcode=instance.SetViewVector
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for BuildRender
Addrfunc=&MD3_INSTANCE_BuildRender()
instance.BuildRender = &instance.bBuildRender[]
Adrnewcode=instance.BuildRender
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for BuildBox
Addrfunc=&MD3_INSTANCE_BuildBox()
instance.BuildBox = &instance.bBuildBox[]
Adrnewcode=instance.BuildBox
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

'Add Wrapper for SetSurfaceFlags
Addrfunc=&MD3_INSTANCE_SetSurfaceFlags()
instance.SetSurfaceFlags = &instance.bSetSurfaceFlags[]
Adrnewcode=instance.SetSurfaceFlags
MD3_WarpBuilder (Addrinst,Addrfunc,Adrnewcode)

debug_pop()
END FUNCTION
'
' ##################################
' #####  MD3_INSTANCE_Destroy  #####
' ##################################
'
FUNCTION MD3_INSTANCE_Destroy (tMD3instance instance)
SHARED MD3_INFOS MD3i
debug_push("MD3_INSTANCE_Destroy ("+HEXX$(&instance)+")")
FOR i=0 TO instance.nSurfaces-1
	IF instance.pVerts[i] THEN @MD3i.mFree(instance.pVerts[i])
	IF instance.pShadowFrontTris[i] THEN @MD3i.mFree(instance.pShadowFrontTris[i])
	IF instance.pShadowEdges[i] THEN @MD3i.mFree(instance.pShadowEdges[i])

NEXT
debug_pop()
END FUNCTION
'
' ####################################
' #####  MD3_INSTANCE_BuildAnim  #####
' ####################################
'
FUNCTION MD3_INSTANCE_BuildAnim (tMD3instance instance,currentfrm,nextfrm,SINGLE pct,flags)
SHARED MD3_INFOS MD3i
SHARED tMD3Model MD3m[]
SHARED tMD3ModelFrames MD3f[]
SINGLE op1,op2
STATIC CVector3 origin1,boxmin1,boxmax1,origin2,boxmin2,boxmax2,origin,boxmax,boxmin,tvect
STATIC tMD3Tag tag1,tag2
debug_push("MD3_INSTANCE_BuildAnim ("+HEXX$(&instance)+","+STRING$(currentfrm)+","+STRING$(nextfrm)+","+STRING$(pct)+","+STRING$(flags)+")")

IF ((currentfrm<0) OR (currentfrm>MD3m[instance.model].nFrames)) THEN
debug_pop()
RETURN
ENDIF

IF ((nextfrm<0) OR (nextfrm>MD3m[instance.model].nFrames)) THEN
debug_pop()
RETURN
ENDIF

IF (flags AND $$MD3_DONOTUPDATE)=0 THEN

FOR i=0 TO instance.nSurfaces-1
	IF (instance.pVerts[i]) THEN
		IF(instance.surfaceflags[i] AND $$MD3_SURFACE_FLAG_IGNORE)=0 THEN
		addrd=instance.pVerts[i]
		addro=MD3m[instance.model].surface[i].pVerts

		l=MD3m[instance.model].surface[i].sFrame
		addro1=addro+(currentfrm*l)
		addro2=addro+(nextfrm*l)

		@MD3i.FloatInterpol(addro1,addro2,addrd,l/4,pct)

		'FOR j=0 TO (l/4)
		'op1=SINGLEAT(addro1)
		'op2=SINGLEAT(addro2)
		'SINGLEAT(addrd)=op1+((op2-op1)*pct)
		'addrd=addrd+4
		'addro1=addro1+4
		'addro2=addro2+4
		'NEXT
		ENDIF
	ENDIF
NEXT

ENDIF

'anyway we can skip mesh/surface calculation if object is not visible
'but boxes and vectors needs to be updated for collision detection

	'origin1 = MD3f[instance.model].cFrame[currentfrm].frame.origin
	'boxmin1 = MD3f[instance.model].cFrame[currentfrm].frame.boxmin
	'boxmax1 = MD3f[instance.model].cFrame[currentfrm].frame.boxmax

	'origin2 = MD3f[instance.model].cFrame[nextfrm].frame.origin
	'boxmin2 = MD3f[instance.model].cFrame[nextfrm].frame.boxmin
	'boxmax2 = MD3f[instance.model].cFrame[nextfrm].frame.boxmax

	'origin.x = origin1.x + ((origin2.x-origin1.x)*pct)
	'origin.y = origin1.y + ((origin2.y-origin1.y)*pct)
	'origin.z = origin1.z + ((origin2.z-origin1.z)*pct)

	'boxmin.x = boxmin1.x + ((boxmin2.x-boxmin1.x)*pct)
	'boxmin.y = boxmin1.y + ((boxmin2.y-boxmin1.y)*pct)
	'boxmin.z = boxmin1.z + ((boxmin2.z-boxmin1.z)*pct)

	'boxmax.x = boxmax1.x + ((boxmax2.x-boxmax1.x)*pct)
	'boxmax.y = boxmax1.y + ((boxmax2.y-boxmax1.y)*pct)
	'boxmax.z = boxmax1.z + ((boxmax2.z-boxmax1.z)*pct)

@MD3i.FloatInterpol(&MD3f[instance.model].cFrame[currentfrm].frame.boxmin,&MD3f[instance.model].cFrame[nextfrm].frame.boxmin,&instance.boxmin,12,pct)

	'build boxes

'instance.boxmin=boxmin
'instance.boxmax=boxmax
'instance.origin=origin

boxmin=instance.boxmin
boxmax=instance.boxmax
'origin=instance.origin

'f 0-0
tvect.x=boxmin.x
tvect.y=boxmin.y
tvect.z=boxmax.z
instance.fp1=tvect
'f 0-1
tvect.x=boxmin.x
tvect.y=boxmax.y
tvect.z=boxmax.z
instance.fp2=tvect
'f 1-1
tvect.x=boxmax.x
tvect.y=boxmax.y
tvect.z=boxmax.z
instance.fp3=tvect
'f 1-0
tvect.x=boxmax.x
tvect.y=boxmin.y
tvect.z=boxmax.z
instance.fp4=tvect
'back face
'b 0-0
tvect.x=boxmin.x
tvect.y=boxmin.y
tvect.z=boxmin.z
instance.bp1=tvect
'b 0-1
tvect.x=boxmin.x
tvect.y=boxmax.y
tvect.z=boxmin.z
instance.bp2=tvect
'b 1-1
tvect.x=boxmax.x
tvect.y=boxmax.y
tvect.z=boxmin.z
instance.bp3=tvect
'b 1-0
tvect.x=boxmax.x
tvect.y=boxmin.y
tvect.z=boxmin.z
instance.bp4=tvect

FOR i=0 TO MD3m[instance.model].nTags
	'instance.tag[i]=MD3f[instance.model].cFrame[frm].tag[i]
	tag1=MD3f[instance.model].cFrame[currentfrm].tag[i]
	tag2=MD3f[instance.model].cFrame[nextfrm].tag[i]

	instance.tag[i].origin.x = tag1.origin.x+((tag2.origin.x-tag1.origin.x)*pct)
	instance.tag[i].origin.y = tag1.origin.y+((tag2.origin.y-tag1.origin.y)*pct)
	instance.tag[i].origin.z = tag1.origin.z+((tag2.origin.z-tag1.origin.z)*pct)

	instance.tag[i].quat.x = tag1.quat.x+((tag2.quat.x-tag1.quat.x)*pct)
	instance.tag[i].quat.y = tag1.quat.y+((tag2.quat.y-tag1.quat.y)*pct)
	instance.tag[i].quat.z = tag1.quat.z+((tag2.quat.z-tag1.quat.z)*pct)
	instance.tag[i].quat.w = tag1.quat.w+((tag2.quat.w-tag1.quat.w)*pct)

NEXT

debug_pop()

END FUNCTION
'
' ######################################
' #####  MD3_INSTANCE_BuildStatic  #####
' ######################################
'
FUNCTION MD3_INSTANCE_BuildStatic (tMD3instance instance,frm)
SHARED MD3_INFOS MD3i
SHARED tMD3Model MD3m[]
SHARED tMD3ModelFrames MD3f[]
CVector3 boxmin,boxmax,tvect

debug_push("MD3_INSTANCE_BuildStatic ("+HEXX$(&instance)+","+STRING$(frm)+")")

IF ((frm<0) OR (frm>MD3m[instance.model].nFrames)) THEN
debug_pop()
RETURN
ENDIF

FOR i=0 TO instance.nSurfaces-1
	IF (instance.pVerts[i]) THEN
		IF(instance.surfaceflags[i] AND $$MD3_SURFACE_FLAG_IGNORE)=0 THEN
		addrd=instance.pVerts[i]
		addro=MD3m[instance.model].surface[i].pVerts

		l=MD3m[instance.model].surface[i].sFrame
		addro=addro+(frm*l)
		MD3_mCopyMemory(addrd,addro,l)
		ENDIF
	ENDIF
NEXT

	instance.origin = MD3f[instance.model].cFrame[frm].frame.origin
	instance.boxmin = MD3f[instance.model].cFrame[frm].frame.boxmin
	instance.boxmax = MD3f[instance.model].cFrame[frm].frame.boxmax

FOR i=0 TO MD3m[instance.model].nTags
	instance.tag[i]=MD3f[instance.model].cFrame[frm].tag[i]

NEXT

'build boxes

boxmin=instance.boxmin
boxmax=instance.boxmax

'f 0-0
tvect.x=boxmin.x
tvect.y=boxmin.y
tvect.z=boxmax.z
instance.fp1=tvect
'f 0-1
tvect.x=boxmin.x
tvect.y=boxmax.y
tvect.z=boxmax.z
instance.fp2=tvect
'f 1-1
tvect.x=boxmax.x
tvect.y=boxmax.y
tvect.z=boxmax.z
instance.fp3=tvect
'f 1-0
tvect.x=boxmax.x
tvect.y=boxmin.y
tvect.z=boxmax.z
instance.fp4=tvect
'back face
'b 0-0
tvect.x=boxmin.x
tvect.y=boxmin.y
tvect.z=boxmin.z
instance.bp1=tvect
'b 0-1
tvect.x=boxmin.x
tvect.y=boxmax.y
tvect.z=boxmin.z
instance.bp2=tvect
'b 1-1
tvect.x=boxmax.x
tvect.y=boxmax.y
tvect.z=boxmin.z
instance.bp3=tvect
'b 1-0
tvect.x=boxmax.x
tvect.y=boxmin.y
tvect.z=boxmin.z
instance.bp4=tvect

debug_pop()

END FUNCTION

' #####################################
' #####  MD3_INSTANCE_ShowShadow  #####
' #####################################
'
FUNCTION MD3_INSTANCE_ShowShadow (tMD3instance instance)
SHARED tMD3Model MD3m[]
SHARED tMD3ModelFrames MD3f[]
SHARED MD3_INFOS MD3i

glPushMatrix()
glMultMatrixf(&instance.iMatrix[])
model=instance.model
nSurfaces=instance.nSurfaces

FOR i=0 TO nSurfaces-1
	IF ((instance.pVerts[i]) AND ((instance.surfaceflags[i] AND $$MD3_SURFACE_FLAG_IGNORE))=0) THEN
		p=0
		addrVerts=instance.pVerts[i]
		glColor3f(1,1,1)
		glBegin($$GL_TRIANGLES)
		FOR j=0 TO instance.nShadowTris[i]
		addrTris=XLONGAT(instance.pShadowFrontTris[i]+p)
		'@MD3i.Print(STRING$(addrTris))
		addrTris=MD3m[model].surface[i].pTriangles+(addrTris*12)

		p1=XLONGAT(addrTris)
		p2=XLONGAT(addrTris+4)
		p3=XLONGAT(addrTris+8)

		p1=addrVerts+(p1*24)
		p2=addrVerts+(p2*24)
		p3=addrVerts+(p3*24)


		glVertex3fv(p1)
		glVertex3fv(p2)
		glVertex3fv(p3)


		p=p+4

		NEXT
		glEnd()

		glColor3f(1,0,0)
		glBegin($$GL_LINES)

		p=0
		addr=instance.pShadowEdges[i]
		FOR j=0 TO instance.nShadowEdges[i]
		IF XLONGAT(addr+8)=1 THEN
		v1=XLONGAT(addr)
		v2=XLONGAT(addr+4)
		v1=addrVerts+(v1*24)
		v2=addrVerts+(v2*24)
		glVertex3fv(v1)
		glVertex3fv(v2)
		ENDIF
		addr=addr+12
		NEXT
		glEnd()
	ENDIF
NEXT

	glColor3f(0,1,0)
	glBegin($$GL_POINTS)
	glVertex3f(instance.vLpos.x,instance.vLpos.y,instance.vLpos.z)
	glEnd()


glPopMatrix()

END FUNCTION
'
' ######################################
' #####  MD3_INSTANCE_BuildShadow  #####
' ######################################
'
FUNCTION MD3_INSTANCE_BuildShadow (tMD3instance instance,CVector4 lppos)
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i
STATIC CVector3 tvect,tnorm
CVector4 lpos
SINGLE tlen,dotp,x,y,z

debug_push("MD3_INSTANCE_BuildShadow ("+HEXX$(&instance)+","+HEXX$(&lpos)+")")

'for all surfaces
'for all tris, if tris face to light ==> add to pShadowFrontVerts and pShadowBackVerts - INC nShadowVerts
'for all edge, if edge shared by 1 tris, edge is part silhouette

'transform lightpos global position to local position relative to the mesh
'@MD3i.Print(STRING$(lppos.x)+","+STRING$(lppos.y)+","+STRING$(lppos.z))
lpos.x=lppos.x -instance.iMatrix[12]
lpos.y=lppos.y -instance.iMatrix[13]
lpos.z=lppos.z -instance.iMatrix[14]

'@MD3i.Print(STRING$(lpos.x)+","+STRING$(lpos.y)+","+STRING$(lpos.z))

instance.vLpos.x=lpos.x*instance.iMatrix[0]+lpos.y*instance.iMatrix[1]+lpos.z*instance.iMatrix[2]
instance.vLpos.y=lpos.x*instance.iMatrix[4]+lpos.y*instance.iMatrix[5]+lpos.z*instance.iMatrix[6]
instance.vLpos.z=lpos.x*instance.iMatrix[8]+lpos.y*instance.iMatrix[9]+lpos.z*instance.iMatrix[10]

x=instance.vLpos.x
y=instance.vLpos.y
z=instance.vLpos.z

model=instance.model

FOR i=0 TO instance.nSurfaces-1
	IF ((instance.pVerts[i]) AND ((instance.surfaceflags[i] AND $$MD3_SURFACE_FLAG_IGNORE))=0) THEN

		addrVerts=instance.pVerts[i]
		instance.nShadowTris[i]=-1
		instance.nShadowEdges[i]=-1
		p=0
		ptris=MD3m[model].surface[i].pTriangles

		'inspect all tris
		FOR j=0 TO MD3m[model].surface[i].nTriangles-1
		addrTris=ptris+(j*12)
		'TEMP:calculate center of the tris and average normal,
		'this part has to be removed and inclued in frame vertices calculation
		p1=(XLONGAT(addrTris))*24
		p2=(XLONGAT(addrTris+4))*24
		p3=(XLONGAT(addrTris+8))*24

		tvect.x = (SINGLEAT(addrVerts+p1)+SINGLEAT(addrVerts+p2)+SINGLEAT(addrVerts+p3))/3
		tvect.y = (SINGLEAT(addrVerts+p1+4)+SINGLEAT(addrVerts+p2+4)+SINGLEAT(addrVerts+p3+4))/3
		tvect.z = (SINGLEAT(addrVerts+p1+8)+SINGLEAT(addrVerts+p2+8)+SINGLEAT(addrVerts+p3+8))/3

	  tnorm.x = (SINGLEAT(addrVerts+p1+12)+SINGLEAT(addrVerts+p2+12)+SINGLEAT(addrVerts+p3+12))/3
		tnorm.y = (SINGLEAT(addrVerts+p1+16)+SINGLEAT(addrVerts+p2+16)+SINGLEAT(addrVerts+p3+16))/3
		tnorm.z = (SINGLEAT(addrVerts+p1+20)+SINGLEAT(addrVerts+p2+20)+SINGLEAT(addrVerts+p3+20))/3

		'determine vector between light and tris center
		tvect.x=x-tvect.x
		tvect.y=y-tvect.y
		tvect.z=z-tvect.z
		'normalise vector
		tlen=Sqrt((tvect.x*tvect.x)+(tvect.y*tvect.y)+(tvect.z*tvect.z))
		'@MD3i.Print(STRING$(tlen))

		IF tlen<0.001 THEN tlen=0.001
		tvect.x=tvect.x/tlen
		tvect.y=tvect.y/tlen
		tvect.z=tvect.z/tlen
		'determine if light with dotproduct
		dotp=tvect.x*tnorm.x+tvect.y*tnorm.y+tvect.z*tnorm.z
		'@MD3i.Print(STRING$(dotp))

			IF dotp<0 THEN
			'if face back to light so add to shadow
			INC instance.nShadowTris[i]
			XLONGAT(instance.pShadowFrontTris[i]+p)=j
			p=p+4
			'@MD3i.Print(STRING$(i)+","+STRING$(j))
			'check edges of this tris
			p1=XLONGAT(addrTris)
			p2=XLONGAT(addrTris+4)
			p3=XLONGAT(addrTris+8)

			MD3_INSTANCE_AddEdge(@instance,i,p1,p2)
			MD3_INSTANCE_AddEdge(@instance,i,p2,p3)
			MD3_INSTANCE_AddEdge(@instance,i,p3,p1)

			ENDIF

		NEXT

	ENDIF
	'@MD3i.Print(STRING$(i)+","+STRING$(instance.nShadowEdges[i]))
NEXT

debug_pop()

END FUNCTION
'
' ##################################
' #####  MD3_INSTANCE_AddEdge  #####
' ##################################
'
FUNCTION MD3_INSTANCE_AddEdge (tMD3instance instance,surface,vert1,vert2)
'check if this edge is in edges list for shadow building
'if already in list, inc count , else add to list
'if count=1 , this is a silhouette edge
SHARED MD3_INFOS MD3i

debug_push("MD3_INSTANCE_AddEdge ("+HEXX$(&instance)+","+STRING$(surface)+","+STRING$(vert1)+","+STRING$(vert2)+")")

addr=instance.pShadowEdges[surface]
FOR i=0 TO instance.nShadowEdges[surface]

IF ((vert1=XLONGAT(addr)) AND (vert2=XLONGAT(addr+4))) THEN
		XLONGAT(addr+8) = XLONGAT(addr+8)+1
		debug_pop()
		RETURN
ENDIF

IF ((vert2=XLONGAT(addr)) AND (vert1=XLONGAT(addr+4))) THEN
		XLONGAT(addr+8) = XLONGAT(addr+8)+1
		debug_pop()
		RETURN
ENDIF

addr=addr+12
NEXT

INC instance.nShadowEdges[surface]
XLONGAT(addr)=vert1
XLONGAT(addr+4)=vert2
XLONGAT(addr+8)=1
debug_pop()
END FUNCTION
'
' ##############################
' #####  MD3_RenderMethod  #####
' ##############################
'
FUNCTION MD3_RenderMethod (tMD3instance instance,surface,flags)
SHARED MD3_INFOS MD3i
SHARED tMD3Model MD3m[]
SHARED tMD3ModelFrames MD3f[]
debug_push("MD3_RenderMethod ("+HEXX$(&instance)+","+STRING$(surface)+","+STRING$(flags)+")")

glPushMatrix()
glMultMatrixf(&instance.iMatrix[])
model=instance.model

i=surface

	IF instance.pVerts[i] THEN
		addrVerts=instance.pVerts[i]
		addrTexCoords=MD3m[model].surface[i].pTxCoords
		addrTris=MD3m[model].surface[i].pTriangles
		nTris=MD3m[model].surface[i].nTriangles

		glVertexPointer(3, $$GL_FLOAT, 24, addrVerts)
		glEnableClientState($$GL_VERTEX_ARRAY)

		IF (flags AND $$MD3_DEF_LIGHT) THEN
		glNormalPointer($$GL_FLOAT,24,addrVerts+12)
		glEnableClientState($$GL_NORMAL_ARRAY)
		ENDIF

		IF (flags AND $$MD3_DEF_TEXTURE) THEN
		glTexCoordPointer(2, $$GL_FLOAT, 8, addrTexCoords)
		glEnableClientState($$GL_TEXTURE_COORD_ARRAY)
		ENDIF

	  glDrawElements($$GL_TRIANGLES , nTris*3, $$GL_UNSIGNED_INT, addrTris )

	ENDIF

glPopMatrix()
debug_pop()
END FUNCTION
'
' ######################################
' #####  MD3_INSTANCE_BuildRender  #####
' ######################################
'
FUNCTION MD3_INSTANCE_BuildRender (tMD3instance instance)
SHARED tMD3Model MD3m[]
SHARED tMD3ModelFrames MD3f[]
SHARED MD3_INFOS MD3i
debug_push("MD3_INSTANCE_BuildRender ("+HEXX$(&instance)+")")
model=instance.model
nSurfaces=instance.nSurfaces

FOR i=0 TO nSurfaces-1
	IF (instance.pVerts[i]) THEN
		IF(instance.surfaceflags[i] AND $$MD3_SURFACE_FLAG_IGNORE)=0 THEN
			@MD3i.PushSurface(&MD3m[],&instance,instance.shaderID[i],i)
		ENDIF
	ENDIF
NEXT
debug_pop()
END FUNCTION

' #############################
' #####  MD3_CheckExists  #####
' #############################
'
FUNCTION MD3_CheckExists (a$)
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i
debug_push("MD3_CheckExists ("+a$+")")
FOR i=0 TO MD3i.LastModel

	IF MD3m[i].strName = a$ THEN
	debug_pop()
	RETURN(i)
	ENDIF

NEXT

debug_pop()
RETURN (-1)

END FUNCTION
'
' #############################
' #####  MD3_SurfaceList  #####
' #############################
'
FUNCTION MD3_SurfaceList (model,addrRet)
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i
FUNCADDR retfunc(STRING,XLONG)

debug_push("MD3_SurfaceList ("+STRING$(model)+","+HEXX$(addrRet)+")")


IF (model<0) THEN
debug_pop()
RETURN
ENDIF

IF (model>MD3i.Maxmodels) THEN
debug_pop()
RETURN
ENDIF

IF (MD3m[i].flags AND $$MD3_LOADED)=0 THEN
debug_pop()
RETURN
ENDIF

retfunc=addrRet

FOR i=0 TO MD3m[model].nSurfaces-1

a$=MD3m[model].surface[i].strName

@retfunc(a$,i)

NEXT

END FUNCTION

'
' ###########################
' #####  MD3_ModelList  #####
' ###########################
'
FUNCTION MD3_ModelList (addrRet)
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i
FUNCADDR retfunc(STRING,XLONG)
debug_push("MD3_ModelList ("+HEXX$(addrRet)+")")

retfunc=addrRet

FOR i=0 TO MD3i.Maxmodels

	IF (MD3m[i].flags AND $$MD3_LOADED) THEN
		a$=MD3m[i].strName
		@retfunc(@a$,i)
	ENDIF
NEXT

debug_pop()
END FUNCTION
'
' #####################
' #####  MD3_New  #####
' #####################
'
FUNCTION MD3_New ()
SHARED tMD3Model MD3m[]
SHARED MD3_INFOS MD3i

debug_push("MD3_New ()")

FOR i=0 TO MD3i.Maxmodels

	IF (MD3m[i].flags AND $$MD3_LOADED)=0 THEN
		IF i>MD3i.LastModel	THEN MD3i.LastModel=i
		debug_pop()
		RETURN (i)
	ENDIF
NEXT
@MD3i.Print("MD3_New:Max models limit reached")
debug_pop()
RETURN (-1)

END FUNCTION
'
' ######################################
' #####  MD3_INSTANCE_SetIdentity  #####
' ######################################
'
FUNCTION MD3_INSTANCE_SetIdentity (tMD3instance instance,SINGLE x,SINGLE y,SINGLE z,CVector3 angles)
SINGLE a,b,c,d,e,f,ad,bd
debug_push("MD3_INSTANCE_SetIdentity ("+HEXX$(&instance)+","+STRING$(x)+","+STRING$(y)+","+STRING$(z)+","+HEXX$(&angles)+")")
angles.y=angles.y-90

a = Cos(angles.x*$$DEGTORAD)
b = Sin(angles.x*$$DEGTORAD)
c = Cos(angles.y*$$DEGTORAD)
d = Sin(angles.y*$$DEGTORAD)
e = Cos(angles.z*$$DEGTORAD)
f = Sin(angles.z*$$DEGTORAD)

ad=a*d
bd=b*d

instance.iMatrix[0]=c*e
instance.iMatrix[1]=-bd * e + a * f
instance.iMatrix[2]=ad * e + b * f
instance.iMatrix[3]=0!

instance.iMatrix[4]=-c*f
instance.iMatrix[5]=bd * f + a * e
instance.iMatrix[6]=-ad * f + b * e
instance.iMatrix[7]=0!

instance.iMatrix[8]=-d
instance.iMatrix[9]=-b * c
instance.iMatrix[10]=a*c
instance.iMatrix[11]=0!

instance.iMatrix[12]=x
instance.iMatrix[13]=y
instance.iMatrix[14]=z
instance.iMatrix[15]=1!

debug_pop()

END FUNCTION
'
' ###################################
' #####  MD3_INSTANCE_GetTagID  #####
' ###################################
'
FUNCTION MD3_INSTANCE_GetTagID (tMD3instance instance,name$)
SHARED tMD3Model MD3m[]
debug_push("MD3_INSTANCE_GetTagID ("+HEXX$(&instance)+","+name$+")")
FOR i=0 TO MD3m[instance.model].nTags
	IF name$=MD3m[instance.model].strTagName[i] THEN
	debug_pop()
	RETURN (i)
	ENDIF
NEXT
debug_pop()
RETURN(-1)
END FUNCTION
'
' ###############################
' #####  MD3_INSTANCE_Link  #####
' ###############################
'
FUNCTION MD3_INSTANCE_Link (tMD3instance instanceO,tMD3instance instanceD,linkID,CVector3 angles)
STATIC SINGLE tMat[],Mat[],rMat[]
STATIC init
SINGLE a,b,c,d,e,f,ad,bd

debug_push("MD3_INSTANCE_Link ("+HEXX$(&instanceO)+","+HEXX$(&instanceD)+","+STRING$(linkID)+","+HEXX$(&angles)+")")

IFZ init THEN
DIM tMat[15]
DIM Mat[15]
DIM rMat[15]
init=0
ENDIF

IF (linkID<0) THEN
debug_pop()
RETURN
ENDIF

	MD3_MATH_QuatToMatrix (&tMat[],&instanceO.tag[linkID].quat)

	tMat[12]=instanceO.tag[linkID].origin.x
	tMat[13]=instanceO.tag[linkID].origin.y
	tMat[14]=instanceO.tag[linkID].origin.z

	IF ((ABS(angles.x)=0) AND (ABS(angles.y)=0) AND(ABS(angles.z)=0)) THEN
		MD3_MATH_MatrixMultiply(&instanceO.iMatrix[],&tMat[],&instanceD.iMatrix[])

	ELSE

		a = Cos(angles.x*$$DEGTORAD)
		b = Sin(angles.x*$$DEGTORAD)
		c = Cos(angles.y*$$DEGTORAD)
		d = Sin(angles.y*$$DEGTORAD)
		e = Cos(angles.z*$$DEGTORAD)
		f = Sin(angles.z*$$DEGTORAD)

		ad=a*d
		bd=b*d

		Mat[0]=c*e
		Mat[1]=-bd * e + a * f
		Mat[2]=ad * e + b * f
		Mat[3]=0!

		Mat[4]=-c*f
		Mat[5]=bd * f + a * e
		Mat[6]=-ad * f + b * e
		Mat[7]=0!

		Mat[8]=-d
		Mat[9]=-b * c
		Mat[10]=a*c
		Mat[11]=0!

		Mat[12]=0!
		Mat[13]=0!
		Mat[14]=0!
		Mat[15]=1!

		MD3_MATH_MatrixMultiply(&tMat[],&Mat[],&rMat[])
		MD3_MATH_MatrixMultiply(&instanceO.iMatrix[],&rMat[],&instanceD.iMatrix[])

	ENDIF
debug_pop()
END FUNCTION
'
' ###################################
' #####  MD3_INSTANCE_BuildBox  #####
' ###################################
'
FUNCTION MD3_INSTANCE_BuildBox (tMD3instance instance)
SINGLE tMat[]

debug_push("MD3_INSTANCE_BuildBox ("+HEXX$(&instance)+")")

DIM tMat[15]

MD3_mCopyMemory(&tMat[0],&instance.iMatrix[0],64)

MD3_MATH_MatVect (@tMat[],@instance.fp1)
MD3_MATH_MatVect (@tMat[],@instance.fp2)
MD3_MATH_MatVect (@tMat[],@instance.fp3)
MD3_MATH_MatVect (@tMat[],@instance.fp4)

MD3_MATH_MatVect (@tMat[],@instance.bp1)
MD3_MATH_MatVect (@tMat[],@instance.bp2)
MD3_MATH_MatVect (@tMat[],@instance.bp3)
MD3_MATH_MatVect (@tMat[],@instance.bp4)

IF instance.ownVV THEN
	MD3_MATH_MatVect (@tMat[],@instance.oView)
	MD3_MATH_MatVect (@tMat[],@instance.dView)
ENDIF

debug_pop()

END FUNCTION
' ##################################
' #####  MD3_INSTANCE_ShowBox  #####
' ##################################
'
FUNCTION MD3_INSTANCE_ShowBox (tMD3instance instance)

IF instance.ownVV THEN
	glColor4f(1,1,1,1)
	glBegin($$GL_POINTS)
	glVertex3fv(&instance.oView)
	glVertex3fv(&instance.dView)
	glEnd()
	glBegin($$GL_LINES)
	glVertex3fv(&instance.oView)
	glColor4f(1,1,1,0.5)
	glVertex3fv(&instance.dView)
	glEnd()
ENDIF

glColor4f(0,1,0,1)

glBegin($$GL_POINTS)
glVertex3fv(&instance.fp1)
glVertex3fv(&instance.fp2)
glVertex3fv(&instance.fp3)
glVertex3fv(&instance.fp4)
glEnd()

glBegin($$GL_POINTS)
glVertex3f(instance.bp1.x,instance.bp1.y,instance.bp1.z)
glVertex3f(instance.bp2.x,instance.bp2.y,instance.bp2.z)
glVertex3f(instance.bp3.x,instance.bp3.y,instance.bp3.z)
glVertex3f(instance.bp4.x,instance.bp4.y,instance.bp4.z)
glEnd()

glColor4f(1,0,0,1)

'front
glBegin($$GL_LINE_LOOP)
glVertex3fv(&instance.fp1)
glVertex3fv(&instance.fp2)
glVertex3fv(&instance.fp3)
glVertex3fv(&instance.fp4)
glEnd()
'back
glBegin($$GL_LINE_LOOP)
glVertex3fv(&instance.bp1)
glVertex3fv(&instance.bp2)
glVertex3fv(&instance.bp3)
glVertex3fv(&instance.bp4)
glEnd()
'left
glBegin($$GL_LINE_LOOP)
glVertex3f(instance.fp1.x,instance.fp1.y,instance.fp1.z)
glVertex3f(instance.fp2.x,instance.fp2.y,instance.fp2.z)
glVertex3f(instance.bp2.x,instance.bp2.y,instance.bp2.z)
glVertex3f(instance.bp1.x,instance.bp1.y,instance.bp1.z)
glEnd()
'right
glBegin($$GL_LINE_LOOP)
glVertex3f(instance.fp3.x,instance.fp3.y,instance.fp3.z)
glVertex3f(instance.fp4.x,instance.fp4.y,instance.fp4.z)
glVertex3f(instance.bp4.x,instance.bp4.y,instance.bp4.z)
glVertex3f(instance.bp3.x,instance.bp3.y,instance.bp3.z)
glEnd()

END FUNCTION
'
' ##########################################
' #####  MD3_INSTANCE_SetSurfaceFlags  #####
' ##########################################
'
FUNCTION MD3_INSTANCE_SetSurfaceFlags (tMD3instance instance,surface,flags)
SHARED tMD3Model MD3m[]

debug_push("MD3_INSTANCE_SetSurfaceFlags ("+HEXX$(&instance)+","+STRING$(surface)+","+STRING$(flags)+")")

IF ((surface<0) OR (surface>MD3m[model].nSurfaces)) THEN
	debug_pop()
	RETURN
	ENDIF

	instance.surfaceflags[surface]=flags

debug_pop()
END FUNCTION

'
' #######################################
' #####  MD3_INSTANCE_GetSurfaceID  #####
' #######################################
'
FUNCTION MD3_INSTANCE_GetSurfaceID (tMD3instance instance,surface$)
SHARED tMD3Model MD3m[]
SHARED tMD3ModelFrames MD3f[]

debug_push("MD3_INSTANCE_GetSurfaceID ("+HEXX$(&instance)+","+surface$+")")

model=instance.model

FOR i=0 TO MD3m[model].nSurfaces
	IF MD3m[model].surface[i].strName = surface$ THEN
		'@MD3i.Print(surface$+" = "+STRING$(i))
		debug_pop()
		RETURN(i)
	ENDIF
NEXT
debug_pop()
RETURN(-1)

END FUNCTION
'
' ###########################################
' #####  MD3_INSTANCE_SetSurfaceShader  #####
' ###########################################
'
FUNCTION MD3_INSTANCE_SetSurfaceShader (tMD3instance instance,surface,shader)
SHARED tMD3Model MD3m[]
debug_push("MD3_INSTANCE_SetSurfaceShader ("+HEXX$(&instance)+","+STRING$(surface)+","+STRING$(shader)+")")

IF ((surface<0) OR (surface>MD3m[model].nSurfaces)) THEN
	debug_pop()
	RETURN
	ENDIF

	instance.shaderID[surface] = shader
	debug_pop()
RETURN shader

END FUNCTION
'
' ##############################
' #####  MD3_MATH_MatVect  #####
' ##############################
'
FUNCTION MD3_MATH_MatVect (SINGLE Matrix[],CVector3 vect)
SINGLE x,y,z,w

x=Matrix[0]*vect.x+Matrix[4]*vect.y+Matrix[08]*vect.z+Matrix[12]
y=Matrix[1]*vect.x+Matrix[5]*vect.y+Matrix[09]*vect.z+Matrix[13]
z=Matrix[2]*vect.x+Matrix[6]*vect.y+Matrix[10]*vect.z+Matrix[14]
'w=Matrix[3]*vect.x+Matrix[7]*vect.y+Matrix[11]*vect.z+Matrix[15]

vect.x = x
vect.y = y
vect.z = z
RETURN w
END FUNCTION
'
' ####################################
' #####  MD3_INSTANCE_AddVector  #####
' ####################################
'
FUNCTION MD3_INSTANCE_SetViewVector (tMD3instance instance,CVector3 origin,CVector3 dest)

instance.oView=origin
instance.dView=dest
instance.ownVV=1


END FUNCTION
'
' #####################################
' #####  MD3_MATH_Mat3x3ToMat4x4  #####
' #####################################
'
FUNCTION MD3_MATH_Mat3x3ToMat4x4 (SINGLE m3x3[],SINGLE m4x4[])

		m4x4[0]  = m3x3[0]
		m4x4[1]  = m3x3[1]
		m4x4[2]  = m3x3[2]
		m4x4[3]  = 0

		m4x4[4]  = m3x3[3]
		m4x4[5]  = m3x3[4]
		m4x4[6]  = m3x3[5]
		m4x4[7]	 = 0

		m4x4[8]  = m3x3[6]
		m4x4[9]  = m3x3[7]
		m4x4[10] = m3x3[8]
		m4x4[11] = 0

		m4x4[12] = 0
		m4x4[13] = 0
		m4x4[14] = 0
		m4x4[15] = 1
END FUNCTION
'
' ###################################
' #####  MD3_MATH_MatrixToQuat  #####
' ###################################
'
'
FUNCTION MD3_MATH_MatrixToQuat (SINGLE pMatrix[],CVector4 Quat)
SINGLE diagonal,x,y,z,w,scale

diagonal = pMatrix[0] + pMatrix[5] + pMatrix[10] + 1
scale = 0!

IF diagonal> 0.00000001! THEN

	scale = SINGLE(Sqrt(diagonal ) * 2)

	' Calculate the x, y, x and w of the quaternion through the respective equation
	x = ( pMatrix[9] - pMatrix[6] ) / scale
	y = ( pMatrix[2] - pMatrix[8] ) / scale
	z = ( pMatrix[4] - pMatrix[1] ) / scale
	w = 0.25! * scale

ELSE
	IF	((pMatrix[0] > pMatrix[5]) AND (pMatrix[0] > pMatrix[10])) THEN
		scale  = SINGLE(Sqrt( 1.0! + pMatrix[0] - pMatrix[5] - pMatrix[10] ) * 2.0!)
		x = 0.25! * scale
		y = (pMatrix[4] + pMatrix[1] ) / scale
		z = (pMatrix[2] + pMatrix[8] ) / scale
		w = (pMatrix[9] - pMatrix[6] ) / scale
	ELSE
		IF ( pMatrix[5] > pMatrix[10] ) THEN
			scale  = SINGLE(Sqrt( 1.0! + pMatrix[5] - pMatrix[0] - pMatrix[10] ) * 2.0!)
			x = (pMatrix[4] + pMatrix[1] ) / scale
			y = 0.25! * scale
			z = (pMatrix[9] + pMatrix[6] ) / scale
			w = (pMatrix[2] - pMatrix[8] ) / scale
		ELSE
			scale  = SINGLE(Sqrt( 1.0! + pMatrix[10] - pMatrix[0] - pMatrix[5] ) * 2.0!)
			x = (pMatrix[2] + pMatrix[8] ) / scale
			y = (pMatrix[9] + pMatrix[6] ) / scale
			z = 0.25! * scale
			w = (pMatrix[4] - pMatrix[1] ) / scale
		ENDIF
	ENDIF
ENDIF

Quat.x = x
Quat.y = y
Quat.z = z
Quat.w = w

END FUNCTION
'
' ###################################
' #####  MD3_MATH_QuatToMatrix  #####
' ###################################
'
FUNCTION MD3_MATH_QuatToMatrix (SINGLE pMatrix[],CVector4 Quat)
SINGLE x,y,z,w
x=Quat.x
y=Quat.z
z=Quat.z
w=Quat.w

	'First row
	pMatrix[ 0] = 1.0! - 2.0! * ( y * y + z * z )
	pMatrix[ 1] = 2.0! * ( x * y - w * z )
	pMatrix[ 2] = 2.0! * ( x * z + w * y )
	pMatrix[ 3] = 0.0!

	'Second row
	pMatrix[ 4] = 2.0! * ( x * y + w * z )
	pMatrix[ 5] = 1.0! - 2.0! * ( x * x + z * z )
	pMatrix[ 6] = 2.0! * ( y * z - w * x )
	pMatrix[ 7] = 0.0!

	'Third row
	pMatrix[ 8] = 2.0! * ( x * z - w * y )
	pMatrix[ 9] = 2.0! * ( y * z + w * x )
	pMatrix[10] = 1.0! - 2.0! * ( x * x + y * y )
	pMatrix[11] = 0.0!

	'Fourth row
	pMatrix[12] = 0
	pMatrix[13] = 0
	pMatrix[14] = 0
	pMatrix[15] = 1.0!
END FUNCTION
'
' #####################################
' #####  MD3_MATH_MatrixMultiply  #####
' #####################################
'
FUNCTION MD3_MATH_MatrixMultiply (SINGLE dMatrix[],SINGLE oMatrix[],SINGLE rMatrix[])
	rMatrix[ 0] = oMatrix[ 0] * dMatrix[ 0] + oMatrix[ 1] * dMatrix[ 4] + oMatrix[ 2] * dMatrix[ 8] + oMatrix[ 3] * dMatrix[12]
	rMatrix[ 1] = oMatrix[ 0] * dMatrix[ 1] + oMatrix[ 1] * dMatrix[ 5] + oMatrix[ 2] * dMatrix[ 9] + oMatrix[ 3] * dMatrix[13]
	rMatrix[ 2] = oMatrix[ 0] * dMatrix[ 2] + oMatrix[ 1] * dMatrix[ 6] + oMatrix[ 2] * dMatrix[10] + oMatrix[ 3] * dMatrix[14]
	rMatrix[ 3] = oMatrix[ 0] * dMatrix[ 3] + oMatrix[ 1] * dMatrix[ 7] + oMatrix[ 2] * dMatrix[11] + oMatrix[ 3] * dMatrix[15]

	rMatrix[ 4] = oMatrix[ 4] * dMatrix[ 0] + oMatrix[ 5] * dMatrix[ 4] + oMatrix[ 6] * dMatrix[ 8] + oMatrix[ 7] * dMatrix[12]
	rMatrix[ 5] = oMatrix[ 4] * dMatrix[ 1] + oMatrix[ 5] * dMatrix[ 5] + oMatrix[ 6] * dMatrix[ 9] + oMatrix[ 7] * dMatrix[13]
	rMatrix[ 6] = oMatrix[ 4] * dMatrix[ 2] + oMatrix[ 5] * dMatrix[ 6] + oMatrix[ 6] * dMatrix[10] + oMatrix[ 7] * dMatrix[14]
	rMatrix[ 7] = oMatrix[ 4] * dMatrix[ 3] + oMatrix[ 5] * dMatrix[ 7] + oMatrix[ 6] * dMatrix[11] + oMatrix[ 7] * dMatrix[15]

	rMatrix[ 8] = oMatrix[ 8] * dMatrix[ 0] + oMatrix[ 9] * dMatrix[ 4] + oMatrix[10] * dMatrix[ 8] + oMatrix[11] * dMatrix[12]
	rMatrix[ 9] = oMatrix[ 8] * dMatrix[ 1] + oMatrix[ 9] * dMatrix[ 5] + oMatrix[10] * dMatrix[ 9] + oMatrix[11] * dMatrix[13]
	rMatrix[10] = oMatrix[ 8] * dMatrix[ 2] + oMatrix[ 9] * dMatrix[ 6] + oMatrix[10] * dMatrix[10] + oMatrix[11] * dMatrix[14]
	rMatrix[11] = oMatrix[ 8] * dMatrix[ 3] + oMatrix[ 9] * dMatrix[ 7] + oMatrix[10] * dMatrix[11] + oMatrix[11] * dMatrix[15]

	rMatrix[12] = oMatrix[12] * dMatrix[ 0] + oMatrix[13] * dMatrix[ 4] + oMatrix[14] * dMatrix[ 8] + oMatrix[15] * dMatrix[12]
	rMatrix[13] = oMatrix[12] * dMatrix[ 1] + oMatrix[13] * dMatrix[ 5] + oMatrix[14] * dMatrix[ 9] + oMatrix[15] * dMatrix[13]
	rMatrix[14] = oMatrix[12] * dMatrix[ 2] + oMatrix[13] * dMatrix[ 6] + oMatrix[14] * dMatrix[10] + oMatrix[15] * dMatrix[14]
	rMatrix[15] = oMatrix[12] * dMatrix[ 3] + oMatrix[13] * dMatrix[ 7] + oMatrix[14] * dMatrix[11] + oMatrix[15] * dMatrix[15]

END FUNCTION
'
' ###########################
' #####  MD3_SetOption  #####
' ###########################
'
FUNCTION MD3_SetOption (option,value)
SHARED MD3_INFOS MD3i

SELECT CASE option

CASE $$MD3_OPTION_FOPEN
MD3i.fOpen=value

CASE $$MD3_OPTION_FREAD
MD3i.fRead=value

CASE $$MD3_OPTION_FCLOSE
MD3i.fClose=value

CASE $$MD3_OPTION_FSEEK
MD3i.fSeek=value

CASE $$MD3_OPTION_PRINT
MD3i.Print=value

CASE $$MD3_OPTION_MALLOC
MD3i.mAlloc=value

CASE $$MD3_OPTION_MFREE
MD3i.mFree=value

CASE $$MD3_OPTION_SHADER_LOAD
MD3i.SHADER_Load=value

CASE $$MD3_OPTION_SHADER_FREE
MD3i.SHADER_Free=value

CASE $$MD3_OPTION_PUSH_SURFACE
MD3i.PushSurface=value

END SELECT


END FUNCTION
'
' #########################
' #####  MD3_AsmInit  #####
' #########################
'

FUNCTION MD3_AsmInit ()
SHARED MD3_INFOS MD3i

mmx=0b100000000000000000000000

MD3i.DllHdl=LoadLibraryA(&"asmcode.dll")

IF !MD3i.DllHdl THEN RETURN (-1)

f=GetProcAddress(MD3i.DllHdl,&"GetCPUID")
MD3i.GetCPUID=f

MD3i.CopyMemory=GetProcAddress(MD3i.DllHdl,&"MemCopy")
MD3i.CopyMemoryMMX=GetProcAddress(MD3i.DllHdl,&"MemCopyMMX")
MD3i.FloatInterpol=GetProcAddress(MD3i.DllHdl,&"fInterpol")

adr=@MD3i.GetCPUID()

FOR a=0 TO 11
a$=a$+CHR$(UBYTEAT(adr))
adr=adr+1
NEXT

feats=ULONGAT(adr)

#IsMmx = feats AND mmx

b$="MD3_AsmInit:"
a$="Processor : "+a$
IF #IsMmx THEN
	c$="MMX Detected !"
	ELSE
	c$="No MMX !"
ENDIF

@MD3i.Print(b$)
@MD3i.Print(a$)
@MD3i.Print(c$)

END FUNCTION
'
' #############################
' #####  MD3_mCopyMemory  #####
' #############################
'
FUNCTION MD3_mCopyMemory (dest,org,len)
SHARED MD3_INFOS MD3i

IF #IsMmx THEN
	m8=len/8
	len=len MOD 8
ENDIF

m4=len/4
len=len MOD 4

IF #IsMmx THEN
	@MD3i.CopyMemoryMMX(org,dest,m8,m4,len)
	ELSE
	@MD3i.CopyMemory(org,dest,m4,len)
ENDIF

END FUNCTION
'
' ######################
' #####  MD3_Exit  #####
' ######################
'
FUNCTION MD3_Exit ()
SHARED MD3_INFOS MD3i

FreeLibrary(MD3i.DllHdl)
END FUNCTION
'
' #############################
' #####  MD3_WarpBuilder  #####
' #############################
'
FUNCTION MD3_WarpBuilder (Addrstruct,Addrfunc,dest)

start = GOADDRESS (asmlabelstart)
end = GOADDRESS (asmlabelend)
p1= GOADDRESS (param1)
p2= GOADDRESS (param2)
p1 = dest + (p1-start) + 1
p2 = dest + (p2-start) + 1

MD3_mCopyMemory (dest,start,(end-start)+1)

XLONGAT (p1)=Addrstruct
XLONGAT (p2)=Addrfunc

RETURN
' ASM CODE out of function !

asmlabelstart:
ASM pop EAX
param1:
ASM mov ECX,0
ASM push ECX
ASM push EAX
param2:
ASM mov EAX,0
ASM jmp EAX
asmlabelend:
END FUNCTION

END FUNCTION
'
' #########################
' #####  MD3_Version  #####
' #########################
'

FUNCTION MD3_Version ()
RETURN $$MD3_VERSION
END FUNCTION
