'
' ####################
' #####  PROLOG  #####
' ####################
'
'
VERSION "0.0001"
CONSOLE

IMPORT "xst"

IMPORT "gdi32"
IMPORT "opengl32"
IMPORT "glu32"
IMPORT "sdl"
IMPORT "xfree"
IMPORT "user32"
IMPORT "kernel32"
IMPORT "xio"
IMPORT "xma"

DECLARE FUNCTION Entry ()

m4_include(`md3/md3types.x')

DECLARE FUNCTION DMO_MainLoop ()
DECLARE FUNCTION DMO_InitGFX ()
DECLARE FUNCTION DMO_ExitGFX ()
DECLARE FUNCTION DMO_RenderMD3Mesh (tMD3Model MD3m[],tMD3instance instance,shaderID,surface)

DECLARE FUNCTION KEY_State (keysym)
'logging
DECLARE FUNCTION LogFunc (txt$)
'mem managing
DECLARE FUNCTION MEM_Alloc (nbytes)
DECLARE FUNCTION MEM_Free (hdl)
'file managing
DECLARE FUNCTION FILE_OPEN (fl$,mode)
DECLARE FUNCTION FILE_CLOSE (hdl)
DECLARE FUNCTION FILE_READ (hFile, lpBuffer, nNumberOfBytesToRead)
DECLARE FUNCTION FILE_SEEK (hFile, lDistanceToMove)
'image managing
DECLARE FUNCTION IMG_CheckSize (l,h)
DECLARE FUNCTION IMG_Load (name$)
DECLARE FUNCTION IMG_CreateTexture (data,w,h,format,option)
DECLARE FUNCTION IMG_FindExtension (name$)
DECLARE FUNCTION IMG_Free (hdl)

m4_define(`debug_push','EXCEPT_Push($1))
m4_define(`debug_pop','EXCEPT_Pop())

m4_include(`md3/md3dec.dec')

'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()
SHARED LogHdl
SHARED tMD3instance lower
SHARED tMD3instance upper
SHARED tMD3instance weapon
SHARED tMD3instance head

LogHdl=OPEN("LogFile.txt",$$WRNEW)

XioHideConsole ()

DMO_InitGFX()

'set callback functions
MD3_SetOption($$MD3_OPTION_PRINT,&LogFunc())
MD3_SetOption($$MD3_OPTION_MALLOC,&MEM_Alloc())
MD3_SetOption($$MD3_OPTION_MFREE,&MEM_Free())

MD3_SetOption($$MD3_OPTION_FOPEN,&FILE_OPEN())
MD3_SetOption($$MD3_OPTION_FREAD,&FILE_READ())
MD3_SetOption($$MD3_OPTION_FCLOSE,&FILE_CLOSE())
MD3_SetOption($$MD3_OPTION_FSEEK,&FILE_SEEK())

MD3_SetOption($$MD3_OPTION_SHADER_LOAD,&IMG_Load())
MD3_SetOption($$MD3_OPTION_SHADER_FREE ,&IMG_Free())

MD3_SetOption($$MD3_OPTION_PUSH_SURFACE,&DMO_RenderMD3Mesh())

MD3_Init(32,0)

	hipart=MD3_Load ("players/ryla/upper.md3",0)
	weappart =MD3_Load ("weapons2/railgun/railgun.md3",1) 'autoload shaders for weapon
	lowpart=MD3_Load ("players/ryla/lower.md3",0)
	headpart=MD3_Load ("players/ryla/head.md3",0)

	MD3_INSTANCE_Create(lowpart,@lower)
	MD3_INSTANCE_Create(hipart,@upper)
	MD3_INSTANCE_Create(weappart,@weapon)
	MD3_INSTANCE_Create(headpart,@head)

	'setup shaders for legs
	l_legs = @lower.GetSurfaceID("l_legs")
	l_armor = @lower.GetSurfaceID ("l_armor")
	t_l_legs = IMG_Load("models/players/ryla/body_b")
	t_l_armor = IMG_Load("models/players/ryla/armor_b")
	@lower.SetSurfaceShader(l_legs,t_l_legs)
	@lower.SetSurfaceShader(l_armor,t_l_armor)

	'setup shaders for torso
	u_torso = @upper.GetSurfaceID("u_torso")
	u_armor = @upper.GetSurfaceID("u_armor")
	t_u_torso = IMG_Load("models/players/ryla/body_b")
	t_u_armor = IMG_Load("models/players/ryla/armor_b")
	@upper.SetSurfaceShader(u_torso,t_u_torso)
	@upper.SetSurfaceShader(u_armor,t_u_armor)

	'hide armor parts for upper and lower, just for testing this func
	@upper.SetSurfaceFlags(u_armor,$$MD3_SURFACE_FLAG_IGNORE)
	@lower.SetSurfaceFlags(l_armor,$$MD3_SURFACE_FLAG_IGNORE)

	'setup shaders for head
	h_head = @head.GetSurfaceID("h_head")
	h_hair = @head.GetSurfaceID("h_hair")
	t_h_head = IMG_Load("models/players/ryla/head_r")
	t_h_hair = IMG_Load("models/players/ryla/hair_r")
	@head.SetSurfaceShader(h_head,t_h_head)
	@head.SetSurfaceShader(h_hair,t_h_hair)

DMO_MainLoop()

DMO_ExitGFX()

	@lower.Destroy()
	@upper.Destroy()
	@weapon.Destroy()
	@head.Destroy()

	MD3_Free(lowpart)
	MD3_Free(hipart)
	MD3_Free(weappart)
	MD3_Free(headpart)

MD3_Exit()

CLOSE(LogHdl)

END FUNCTION
'
' ##########################
' #####  DMO_MainLoop  #####
' ##########################
'
FUNCTION DMO_MainLoop ()
SHARED tMD3instance lower
SHARED tMD3instance upper
SHARED tMD3instance weapon
SHARED tMD3instance head

STATIC SINGLE rot
STATIC CVector3 bAngles
STATIC CVector3 cAngles
CVector3 vorg,vdest,vpos

DO
		SDL_PumpEvents()
		glClear($$GL_COLOR_BUFFER_BIT | $$GL_DEPTH_BUFFER_BIT)
		glColor3f(1,1,1)
		glEnable($$GL_TEXTURE_2D)
		glDisable($$GL_LIGHTING)


	'Build meshes
	@lower.BuildStatic(144)
	@upper.BuildStatic(103)
	@head.BuildStatic(0)
	@weapon.BuildStatic(0)

	'Link meshes together
	idtorso = @lower.GetTagID("tag_torso")
	idweap = @upper.GetTagID("tag_weapon")
	idhead = @upper.GetTagID("tag_head")

	rot=rot+.1
	bAngles.y=rot

	@lower.SetIdentity(0,0,-48,bAngles)
	@lower.Link(@upper,idtorso,cAngles)
	@upper.Link(@weapon,idweap,cAngles)
	@upper.Link(@head,idhead,cAngles)

	'Setup vectors and boxes
	vorg.x=18
	vorg.y=3
	vorg.z=.5
	vdest.x=100
	vdest.y=3
	vdest.z=.5
	@weapon.SetViewVector (vorg,vdest)

	vorg.x=0
	vorg.y=2
	vorg.z=0
	vdest.x=40
	vdest.y=2
	vdest.z=0
	@head.SetViewVector (vorg,vdest)

	@lower.BuildBox()
	@upper.BuildBox()
	@head.BuildBox()
	@weapon.BuildBox()

	'push meshes to render
	@lower.BuildRender ()
	@upper.BuildRender ()
	@head.BuildRender ()
	@weapon.BuildRender ()

	'Show collision test boxes
	glDisable($$GL_TEXTURE_2D)
	glDisable($$GL_LIGHTING)

	@lower.ShowBox()
	@upper.ShowBox()
	@head.ShowBox()
	@weapon.ShowBox()

		glFinish()
		SDL_GL_SwapBuffers()

		IF KEY_State($$SDLK_ESCAPE) THEN Fin=1

LOOP UNTIL Fin

END FUNCTION
'
' #########################
' #####  DMO_InitGFX  #####
' #########################
'
FUNCTION DMO_InitGFX ()
SDL_VideoInfo vInfo
SDL_PixelFormat vfmt

'test settings
Larg=640
Haut=480
Bpp=32
Mode = $$SDL_OPENGL ' OR $$SDL_FULLSCREEN

'init SDL
SDL_Init($$SDL_INIT_VIDEO)

SDL_GL_SetAttribute($$SDL_GL_DOUBLEBUFFER,1)
SDL_GL_SetAttribute($$SDL_GL_RED_SIZE,8)
SDL_GL_SetAttribute($$SDL_GL_GREEN_SIZE,8)
SDL_GL_SetAttribute($$SDL_GL_BLUE_SIZE,8)
SDL_GL_SetAttribute($$SDL_GL_ALPHA_SIZE,8)
SDL_GL_SetAttribute($$SDL_GL_DEPTH_SIZE, 16 )

SDLhdl=SDL_SetVideoMode(Larg,Haut,Bpp,Mode)

'init GL
glViewport(0,0,Larg,Haut)
glShadeModel($$GL_SMOOTH)

glClearColor(0,0,0,0)

glMatrixMode($$GL_PROJECTION)
glLoadIdentity()
gluPerspective(90.0!,DOUBLE(Larg)/DOUBLE(Haut), 1.0! , 4000.0!)
glMatrixMode($$GL_MODELVIEW)

glCullFace($$GL_FRONT)
glDepthFunc($$GL_LEQUAL)
glEnable($$GL_DEPTH_TEST)
glDisable($$GL_BLEND)
glPointSize (5)

'init FreeImage
Xfree_Init ()
FreeImage_Initialise (0)

END FUNCTION
'
' #########################
' #####  DMO_ExitGFX  #####
' #########################
'
FUNCTION DMO_ExitGFX ()

SDL_Quit()
FreeImage_DeInitialise()

END FUNCTION
'
' #######################
' #####  KEY_State  #####
' #######################
'
FUNCTION KEY_State (keysym)

addrkeyst=SDL_GetKeyState(0)

RETURN XLONG(UBYTEAT(addrkeyst+keysym))

END FUNCTION
'
' #####################
' #####  LogFunc  #####
' #####################
'

FUNCTION LogFunc (txt$)
SHARED LogHdl

txt$=txt$+CHR$(13)
WRITE [LogHdl],txt$

END FUNCTION
'
' #######################
' #####  MEM_Alloc  #####
' #######################
'
FUNCTION MEM_Alloc (nbytes)
RETURN GlobalAlloc ($$GMEM_FIXED,nbytes)
END FUNCTION
'
' ######################
' #####  MEM_Free  #####
' ######################
'
FUNCTION MEM_Free (hdl)
GlobalFree(hdl)
END FUNCTION
'
' #######################
' #####  FILE_OPEN  #####
' #######################
'
FUNCTION FILE_OPEN (fl$,mode)

dwDesiredAccess = 0

IF ( mode=$$WRNEW ) THEN
	dwDesiredAccess = $$GENERIC_WRITE
	dwCreationDisposition = $$CREATE_ALWAYS
	ELSE
	dwDesiredAccess = $$GENERIC_READ
	dwCreationDisposition = $$OPEN_EXISTING
	ENDIF

RETURN CreateFileA (&fl$,dwDesiredAccess, $$FILE_SHARE_READ OR $$FILE_SHARE_WRITE , 0 , dwCreationDisposition, $$FILE_ATTRIBUTE_ARCHIVE, $$FILE_FLAG_WRITE_THROUGH)


END FUNCTION
'
' ########################
' #####  FILE_CLOSE  #####
' ########################
'
FUNCTION FILE_CLOSE (hdl)
RETURN CloseHandle (hdl)
END FUNCTION
'
' #######################
' #####  FILE_READ  #####
' #######################
'
FUNCTION FILE_READ (hFile, lpBuffer, nNumberOfBytesToRead)
RETURN ReadFile(hFile, lpBuffer, nNumberOfBytesToRead, &lpNumberOfBytesRead, 0)
END FUNCTION
'
' #######################
' #####  FILE_SEEK  #####
' #######################
'
FUNCTION FILE_SEEK (hFile, lDistanceToMove)

RETURN SetFilePointer (hFile, lDistanceToMove, 0 , $$FILE_BEGIN	)
END FUNCTION
'
' ###########################
' #####  IMG_CheckSize  #####
' ###########################
'
'Check if image fits with GL size requirements
'image dimensions must be power of 2
FUNCTION IMG_CheckSize (l,h)

change = 0

IF ( l< 16) THEN
	l = 16
	change =1
ENDIF

IF ( h < 16 ) THEN
	h = 16
	change = 1
ENDIF

FOR i=3 TO 16
		nbr = XLONG ( Power (2,i))
		IF (l<nbr) THEN
			nbr2 = XLONG ( Power (2,i-1))
				IF (l MOD nbr2) THEN
				l = nbr
				change = 1
				ENDIF
			EXIT FOR
		ENDIF
NEXT

FOR i=3 TO 16
		nbr = XLONG ( Power (2,i))
		IF (h<nbr) THEN
			nbr2 = XLONG ( Power (2,i-1))
				IF (h MOD nbr2) THEN
				h = nbr
				change = 1
				ENDIF
			EXIT FOR
		ENDIF
NEXT

RETURN change

END FUNCTION
'
' ######################
' #####  IMG_Load  #####
' ######################
'
FUNCTION IMG_Load (name$)

UBYTE Buffer[]

IMG_FindExtension(@name$)
LogFunc ("IMG_Load: IMG_FindExtension: " + name$)

fif = $$FIF_UNKNOWN
' check the file signature and deduce its format
' (the second argument is currently not used by FreeImage)
fif = FreeImage_GetFileType(&name$, 0)
LogFunc ("IMG_Load: FreeImage_GetFileType: " + STRING$(fif))
 
IF (fif == $$FIF_UNKNOWN) THEN 
' no signature ?
' try to guess the file format from the file extension
	fif = FreeImage_GetFIFFromFilename(&name$)
	LogFunc ("IMG_Load: FreeImage_GetFIFFromFilename: " + STRING$(fif)) 
END IF 

' check that the plugin has reading capabilities ...
IF ((fif != $$FIF_UNKNOWN) && FreeImage_FIFSupportsReading(fif)) THEN 
' ok, let's load the file
' note: freeimage does not like to load compressed tga files
	img = FreeImage_Load(fif, &name$, 0)
	LogFunc ("IMG_Load: FreeImage_Load: img: " + STRING$(img)) 
	IFZ img THEN RETURN 
END IF 

'fif = FreeImage_GetFIFFromFilename ( &name$)
'LogFunc ("IMG_Load: FreeImage_GetFIFFromFilename: " + STRING$(fif)) 

'fl=OPEN(name$,$$RD)
'DIM Buffer[LOF(fl)]
'READ [fl],Buffer[]
'CLOSE (fl)
'size=UBOUND(Buffer[])
'Hdl = FreeImage_OpenMemory (&Buffer[],size)
'img = FreeImage_LoadFromMemory (fif, Hdl, 0)
'FreeImage_CloseMemory (Hdl)

bpp = FreeImage_GetBPP (img)
w = FreeImage_GetWidth (img)
h = FreeImage_GetHeight (img)

SELECT CASE bpp
	CASE 1
		format = $$GL_LUMINANCE 'greyscale are necessary luminance by default
	CASE 24
		format = $$GL_BGR_EXT
	CASE 32
		format = $$GL_BGRA_EXT
	CASE ELSE
		FreeImage_ConvertTo24Bits	(img) 'unknown format, defaulting to RGB
		format = $$GL_BGR_EXT
END SELECT

IF IMG_CheckSize (@w,@h) THEN
	newimg = FreeImage_Rescale (img,w,h,$$FILTER_BILINEAR)
	LogFunc ("IMG_Load: FreeImage_Rescale: newimg: " + STRING$(newimg)) 
	LogFunc ("IMG_Load:"+name$)
	LogFunc ("Invalid GL dimensions    ^^Resized to "+STRING$(w)+"*"+STRING$(h))
	FreeImage_Unload (img)
	img=newimg
END IF

w2 = FreeImage_GetWidth (img)
h2 = FreeImage_GetHeight (img)
data=FreeImage_GetBits(img)
gltex=IMG_CreateTexture (data,w,h,format,1)

FreeImage_Unload (img)

RETURN gltex

END FUNCTION
'
' ###############################
' #####  IMG_CreateTexture  #####
' ###############################
'
'Create texture from image data, option = 1 ==> use mimmap
FUNCTION IMG_CreateTexture (data,w,h,format,option)

SELECT CASE format

	CASE $$GL_LUMINANCE
	bpp = 1

	'Stupid RGB invertion, little endian system :s

	CASE  $$GL_BGR_EXT
	bpp = 3

	CASE	$$GL_BGRA_EXT
	bpp = 4

	CASE	$$GL_RGB
	bpp = 3

	CASE $$GL_RGBA
	bpp = 4

	CASE $$GL_LUMINANCE_ALPHA
	bpp = 2

	CASE ELSE
	LogFunc ("IMG_CreateTexture:Invalid token image format "+STRING$(bpp))
	RETURN (0)

END SELECT

glGenTextures	(1, &texture)
glPixelStorei ($$GL_UNPACK_ALIGNMENT, 1)
glBindTexture	($$GL_TEXTURE_2D, texture)

IF (option) THEN
	gluBuild2DMipmaps($$GL_TEXTURE_2D, bpp, w, h, format, $$GL_UNSIGNED_BYTE, data)
	glTexParameteri($$GL_TEXTURE_2D, $$GL_TEXTURE_MIN_FILTER, $$GL_LINEAR_MIPMAP_NEAREST)
	ELSE
	glTexImage2D($$GL_TEXTURE_2D,0,bpp,w,h,0,format,$$GL_UNSIGNED_BYTE,data)
	glTexParameteri($$GL_TEXTURE_2D, $$GL_TEXTURE_MIN_FILTER, $$GL_LINEAR)
ENDIF


glTexParameteri($$GL_TEXTURE_2D, $$GL_TEXTURE_MAG_FILTER, $$GL_LINEAR)

'--- Parametres par defaut

glTexEnvf($$GL_TEXTURE_ENV, $$GL_TEXTURE_ENV_MODE, $$GL_MODULATE)

RETURN texture

END FUNCTION
'
' ###############################
' #####  IMG_FindExtension  #####
' ###############################
'
FUNCTION IMG_FindExtension (name$)

Hdl=FILE_OPEN(name$+".tga",$$RD)
IF Hdl <> $$INVALID_HANDLE_VALUE THEN
	name$=name$+".tga"
	FILE_CLOSE (Hdl)
	RETURN 1
ENDIF

Hdl=FILE_OPEN(name$+".jpg",$$RD)
IF Hdl <> $$INVALID_HANDLE_VALUE THEN
	name$=name$+".jpg"
	FILE_CLOSE (Hdl)
	RETURN 1
ENDIF

Hdl=FILE_OPEN(name$+".bmp",$$RD)
IF Hdl <> $$INVALID_HANDLE_VALUE THEN
	name$=name$+".bmp"
	FILE_CLOSE (Hdl)
	RETURN 1
ENDIF

Hdl=FILE_OPEN(name$+".png",$$RD)
IF Hdl <> $$INVALID_HANDLE_VALUE THEN
	name$=name$+".png"
	FILE_CLOSE (Hdl)
	RETURN 1
ENDIF

END FUNCTION
'
' ######################
' #####  IMG_Free  #####
' ######################
'

FUNCTION IMG_Free (hdl)

glDeleteTextures(&hdl,1)

END FUNCTION
'
' ###############################
' #####  DMO_RenderMD3Mesh  #####
' ###############################
'
FUNCTION DMO_RenderMD3Mesh (tMD3Model MD3m[],tMD3instance instance,shaderID,surface)
STATIC lastSH

IF lastSH<>shaderID THEN
lastSH=shaderID
glBindTexture($$GL_TEXTURE_2D,shaderID)
ENDIF

MD3_RenderMethod (@instance,surface,$$MD3_DEF_TEXTURE)

END FUNCTION

m4_include(`md3/md3code.x')
END PROGRAM